-- name: King Boo's Revenge X
-- description: A sequal to King Boo's Revenge 2 with 160 stars. Created by Thebloody7.\nPorted by Sunk.
-- incompatible: romhack

gServerSettings.skipIntro = true

-- Can't be bothered testing every course that might need fixed collision so it's just blanket on
function update()
    gLevelValues.fixCollisionBugsRoundedCorners = 0
    gLevelValues.fixCollisionBugs = 1
    if gNetworkPlayers[0].currLevelNum == LEVEL_BBH and gMarioStates[0].pos.y < -8000 then
        gLevelValues.fixCollisionBugs = 1
    end
end

hook_event(HOOK_UPDATE, update)

local is_shell_mario = false

-- Detects if Mario is currently doing the shell mario glitch
---@param m MarioState
---@param obj Object
---@param intType any
function shell_interact(m, obj, intType)
    if m.playerIndex ~= 0 then return end
    ---@type NetworkPlayer
    local np = gNetworkPlayers[0]

    if intType == INTERACT_KOOPA_SHELL and np.currLevelNum == LEVEL_BBH and m.action & ACT_GROUP_MASK == ACT_GROUP_SUBMERGED then
        is_shell_mario = true
    end
end

-- Makes Mario move much faster if he is doing the shell mario glitch.
---@param m MarioState
function before_phys_step(m)
    if m.playerIndex ~= 0 then return end

    local obj = obj_get_nearest_object_with_behavior_id(m.marioObj, id_bhvKoopaShell)

    if dist_between_objects(m.marioObj, obj) > 50 or not obj then
        is_shell_mario = false
    end

    if is_shell_mario then
        m.vel.x = m.vel.x * 4
        m.vel.z = m.vel.z * 4
    end
end

hook_event(HOOK_ON_INTERACT, shell_interact)
hook_event(HOOK_BEFORE_PHYS_STEP, before_phys_step)

-- KBRX makes Mario not die to quicksand if he's vanished
---@param m MarioState
---@param hazardType number
function allow_hazard_surface(m, hazardType)
    if m.playerIndex ~= 0 then return end

    if m.flags & MARIO_VANISH_CAP ~= 0 and hazardType == HAZARD_TYPE_QUICKSAND then
        return false
    end
    return true
end

hook_event(HOOK_ALLOW_HAZARD_SURFACE, allow_hazard_surface)